# Contributing

We welcome any and all contributions to Forecastie. Please add suggestions, bugs or requests for new features to the [Issues](https://github.com/martykan/forecastie/issues) page. The [Issues](https://github.com/martykan/forecastie/issues) page is also the best place to ask questions about the code, the structure of the software, release schedule, etc.

## Pull requests

We also accept pull requests; anything you submit will be reviewed and discussed, and merged if appropriate. Please take the time to read relevant [Issues](https://github.com/martykan/forecastie/issues), or open one yourself on the topic.

## Code guidelines

Although we will discuss every pull request, we'd like you to prepare your contribution as well as possible. Keep your code easy to understand and maintainable as well as consistent with the existing code. Add helpful comments or JavaDoc when necessary.

We don't have a prescribed code style but you can find reasonable guidelines in the [Google Java Style Guide](https://google.github.io/styleguide/javaguide.html) and the [Android Contributors Code Style](https://source.android.com/setup/contribute/code-style).

We currently support devices which run Android version 4.0.3/API 14. We will continue this so those with older Android phones may use the software. Please bear this in mind when preparing code for a pull request.

## Translations

It is very important to have Forecastie available in as many languages as possible: we currently offer 27 languages beside the default English, unfortunately they are not always as up-to-date as they should be. All translators and their contributions are very welcome, please do whatever you can, no matter how small the change. There are two tools available to assist with this work, [Transifex](https://www.transifex.com/forecastie/forecastie/) and a [Python script](https://github.com/martykan/forecastie/blob/master/translation-progress.py) which shows untranslated strings for a selected language.
